(document:surround "/std/frame")

(define (ui-init)
   (form-update-enum "report" (woo-list "/audit/list_report"))
   (form-update-enum "size_page" (woo-list "/audit/list_size_page"))
   (form-update-enum "filters" (woo-list "/audit/list_filter_log"))
   (form-update-enum "start_time" (woo-list "/audit/list_time"))
   (form-update-enum "end_time" (woo-list "/audit/list_time"))
   (let ((data (woo-read-first "/audit/daemon_status")))
      (daemon text (woo-get-option data 'auditd_status)))
   (update-header_log)
)

(define (daemon_turn_off)
   (let ((data (woo-read-first "/audit/daemon_on")))
      (daemon text (woo-get-option data 'auditd_status))))
  

(define (update-header_log)
  (tabels rows-clear)
  (form-update-visibility "tabel" #f)

  (map (lambda(data)
	 (simple-notify tabels 'action "new"
		 		'parent group_tab
				'columns (woo-get-option data 'name)
		 		'type "listbox"
	 ))
       (woo-list "/audit/title_table"))
   
  (map (lambda(data)
	  (tabels columns (woo-get-option data 'name)
		  header (woo-get-option data 'label)
		  ))
	(woo-list "/audit/title_table"))
)

(define (update-table)
  (let ((data (woo-read-first "/audit/config_log" 
			      	     'report (form-value "report")
				     'size_page (form-value "size_page")
				     'summary (form-value "fo_summary")
				     'success (form-value "fo_success")
				     'failed (form-value "fo_failed")
				     'interplet (form-value "fo_interplet")
				     'time (form-value "fo_time")
				     'start_time (form-value "start_time")
				     's_time (form-value "s_time")
				     's_date (form-value "s_date")
				     'end_time (form-value "end_time")
				     'e_time (form-value "e_time")
				     'e_date (form-value "e_date")
				     'parameter (form-value "search_param")
				     )))
    (form-update-value-list '("all_lines" "select_line") data))
  (update-header_log)
  (tabels enumref "/audit/list_table")
  (simple-notify tabels 'action "create-event" 'value "clicked")
  (form-update-value "prev_num" 1)
)

(define (setting_rules)
  (frame:replace "/audit/rules")
)

(define (visible_start_time)
  (if (and (equal? (form-value "start_time") "another")
	   (form-value "fo_time"))
    (begin
      (form-update-visibility "s_date" #t)
      (form-update-visibility "s_time" #t))
    (begin
      (form-update-visibility "s_date" #f)
      (form-update-visibility "s_time" #f)))
  )

(define (visible_end_time)
  (if (and (equal? (form-value "end_time") "another")
	   (form-value "fo_time"))
    (begin
      (form-update-visibility "e_date" #t)
      (form-update-visibility "e_time" #t))
    (begin
      (form-update-visibility "e_date" #f)
      (form-update-visibility "e_time" #f)))
  )

(define (show_time)
  (form-update-visibility "start_time" (form-value "fo_time"))
  (form-update-visibility "end_time" (form-value "fo_time"))
  (form-update-visibility "label_start_time" (form-value "fo_time"))
  (form-update-visibility "label_end_time" (form-value "fo_time"))
  (visible_start_time)
  (visible_end_time))

;---------------------------list all filters---------------
(define (select_filter)
  (form-update-value "name" (filters text))
  (if (string-contains (form-value "filters") "--failed")
    (form-update-value "fo_failed" #t)
    (form-update-value "fo_failed" #f))
  (if (string-contains (form-value "filters") "--success")
    (form-update-value "fo_success" #t)
    (form-update-value "fo_success" #f))
  (if (string-contains (form-value "filters") "--summary")
    (form-update-value "fo_summary" #t)
    (form-update-value "fo_summary" #f))
  (if (string-contains (form-value "filters") "-i")
    (form-update-value "fo_interplet" #t)
    (form-update-value "fo_interplet" #f))
  (if (string-contains (form-value "filters") (or "-ts" "-te"))
    (form-update-value "fo_time" #t)
    (form-update-value "fo_time" #f))
;  (if (string-contains (form-value "filters") "--options")
;    (form-update-value "fo_search" #t)
;    (form-update-value "fo_search" #f))
  
  (let ((data (woo-read "/audit/init_filter" 'params (filters value))))
    (form-update-value-list '("report"
			      "start_time" "end_time"
			      "s_date" "s_time" "e_date" "e_time"
			      "search_param"
			      ) data))
  (show_time)
;  (form-update-visibility "advance_search" (form-value "fo_search"))
)

(define (change_filter mode)
  (form-update-enum "filters" 
		    (woo-list "/audit/change_filter"
				  'mode mode
				  'number (filters current)
			          'name (form-value "name")
				  'report (form-value "report")
				  'summary (form-value "fo_summary")
				  'success (form-value "fo_success")
				  'failed (form-value "fo_failed")
				  'interplet (form-value "fo_interplet")
				  'time (form-value "fo_time")
				  'start_time (form-value "start_time")
				  's_time (form-value "s_time")
				  's_date (form-value "s_date")
				  'end_time (form-value "end_time")
				  'e_time (form-value "e_time")
				  'e_date (form-value "e_date")
				  'parameter (form-value "search_param")
				)
  )
)

(define (f_change_page data)
  (form-update-value-list '("select_line" "prev_num") (woo-read "/audit/page_table" 'page data
										    'size (form-value "size_page")))
  (tabels enumref "/audit/list_table")
)

(define (save_log data)
  (catch/message
    (lambda()
      (woo-write "/audit/save_log" 'full data
	     		       'path (form-value "path_log")
			       ))
    )
  )

;---------------------------addvance search------------
;(define (config_filter)
;  (fil value (list_fo_search text))
;  (fil_check value (car(list_fo_search row-item (list (list_fo_search current) 1))))
;  (fil_val value (car(list_fo_search row-item (list (list_fo_search current) 2))))
;  (form-update-visibility "change_fo_search" #t)
;  (form-update-visibility "delete_fo_search" #t)
;  (form-update-visibility "clean_list_search" #t)
;)
;
;(define (change_search)
;  (list_fo_search row-item (list_fo_search current) (list (fil value)))
;  (list_fo_search row-item (list (list_fo_search current) 1) (list (fil_check value)))
;  (list_fo_search row-item (list (list_fo_search current) 2) (fil_val value))
;)
;
;(define (add_search)
;  (if (and (not (equal? (fil value) ""))
;	   (not (equal? (fil_check value) ""))
;	   (not (equal? (fil_val value)"")) )
;    (list_fo_search append-row (vector (fil value) (fil_check value) (fil_val text)) ))
;)
;
;
;--------------------UI--------------

(define (line)
  (form-update-value "select_line" (+ (string->number (form-value "prev_num")) (tabels current)) )
)

(edit name "prev_num" value 1 visibility #f)

(gridbox
  columns "4;100;4"
  align "top"
  (spacer)
  (vbox
    (hbox align "left;top" 
;	(button (_ "Log Settings") name "log_setting")
;	)
;    (hbox align "left"
	(label (_ "Status: ")) 
	(document:id daemon (button (when clicked (daemon_turn_off))))
  	(label "          ") (button (_ "Setting Rules") name "rules_setting"))
    (document:id group_tab (groupbox (_ "Log audit") height 380
				     (document:id tabels (listbox name "tabel"
 							 (when clicked (line))
								  ))
				     ))
    
    (hbox 
      (hbox align "left"
	  (button (_ "Back") (when clicked (f_change_page "back")))
	  (button (_ "Next") (when clicked (f_change_page "next")))
	  (combobox name "size_page" (when changed (f_change_page "size")))
	  (spinbox name "select_line" minimum "1" step "1"
		   (when changed (f_change_page (form-value "select_line"))))
	  (label "/") (label name "all_lines" value "1")
	   )
      (hbox align "right"
;	    (button (_ "Copy in buffer") (when clicked (woo-write "/audit/copy_buffer")))
	    (label "path:")
	    (edit name "path_log")
	    (button (_ "Save Page") (when clicked (save_log "page")))
	    (button (_ "Save Log") (when clicked (save_log "full")))
	    )
      )

    (separator)

    (gridbox columns "70;50;5;100;5;60"
	     align "top"
      	  (document:id filters (listbox name "filters"
		   (when selected (select_filter))
		   ))
	  (vbox align "top"
	     (groupbox (_ "Filter options") align "top"
		      (vbox
		    	(checkbox (_ "Success") name "fo_success"
				  (when changed (form-update-value "fo_failed" #f)))
			(checkbox (_ "Failed") name "fo_failed"
				  (when changed (form-update-value "fo_success" #f)))
			(checkbox (_ "Summary") name "fo_summary")
			(checkbox (_ "Interplet") name "fo_interplet" value #t))
			(checkbox (_ "time") name "fo_time"
				  (when changed (show_time)))
		     )
		)
	  (spacer)
	  (gridbox columns "0;100"
		   align "top"
		   (label (_ "Name")) (edit name "name")
		   (label (_ "Report")) (combobox name "report")
		   (label (_ "Search")) (edit name "search_param")
		   (label (_ "Start Time") visibility (form-value "fo_time") name "label_start_time" )
		   (combobox name "start_time" visibility (form-value "fo_time")
						      (when changed (visible_start_time)))
		   (dateedit name "s_date" visibility #f)
		   (timeedit name "s_time" visibility #f stop #t)
		   (label (_ "End Time") visibility (form-value "fo_time") name "label_end_time")
		   (combobox name "end_time" visibility (form-value "fo_time")
						      (when changed (visible_end_time)))
		   (dateedit name "e_date" visibility #f)
		   (timeedit name "e_time" visibility #f stop #t)
		   )
	  (spacer)
	  (spacer)
    
    	(hbox 
	  (button (_"Add") (when clicked (change_filter "save")))
	  (button (_"Delete") (when clicked (change_filter "del")))
	  (button (_"Change") (when clicked (change_filter "chan"))))
	(spacer)
	(spacer)
	  (button (_"Update") align "right" (when clicked (update-table) ))
	)
   )
)

(document:root
  (when loaded
    (ui-init)
    (form-bind "rules_setting" "click" setting_rules)
  )
)
